unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Registry;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Reg: TRegistry;
begin
  // letrehozzunk egy TRegistry tipusu valtozot
  Reg := TRegistry.Create(KEY_READ);
  try
    // beallitjuk a fo kulcsot
    Reg.RootKey := HKEY_CURRENT_USER;
    // megprobaljuk megnyitni a mi alkalmazasunk Edit kulcsat
    if Reg.OpenKey('\Software\Mi alkalmazasunk\Edit',False) then
      begin
        // ha sikerult, beolvassuk a szoveget
        Edit1.Text := Reg.ReadString('Text');
      end;
    // megprobaljuk megnyitni a mi alkalmazasunk Form kulcsat
    if Reg.OpenKey('\Software\Mi alkalmazasunk\Form',False) then
      begin
        // ha sikerult, beolvassuk az ablak mereteit
        Top := Reg.ReadInteger('Top');
        Left := Reg.ReadInteger('Left');
        Width := Reg.ReadInteger('Width');
        Height := Reg.ReadInteger('Height');
        if Reg.ReadBool('Maximized') then
          WindowState := wsMaximized
        else
          WindowState := wsNormal;
      end;
  finally
    // felszabaditjuk a valtozot a memoriabol
    Reg.Free;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Reg: TRegistry;
begin
  // letrehozzunk egy TRegistry tipusu valtozot
  Reg := TRegistry.Create(KEY_WRITE);
  try
    // beallitjuk a fo kulcsot
    Reg.RootKey := HKEY_CURRENT_USER;
    // megprobaljuk megnyitni a mi alkalmazasunk Edit kulcsat
    if Reg.OpenKey('\Software\Mi alkalmazasunk\Edit',True) then
      begin
        // ha sikerult, beirjuk a szoveget
        Reg.WriteString('Text',Edit1.Text);
      end;
    // megprobaljuk megnyitni a mi alkalmazasunk Form kulcsat
    if Reg.OpenKey('\Software\Mi alkalmazasunk\Form',True) then
      begin
        // ha sikerult, beirjuk az ablak mereteit
        Reg.WriteInteger('Top',Top);
        Reg.WriteInteger('Left',Left);
        Reg.WriteInteger('Width',Width);
        Reg.WriteInteger('Height',Height);
        Reg.WriteBool('Maximized',WindowState=wsMaximized);
      end;
  finally
    // felszabaditjuk a valtozot a memoriabol
    Reg.Free;
  end;
end;

end.
